#include "mac_uip_functions.h"
#include "httpd.h"


void init_eth_regs(void)
{
	  uip_setipid(0);
	  uip_init();
	  uip_arp_init();
	  //xml_init();
	  httpd_init();

	  macaddr.addr[0] = 0xEA; macaddr.addr[1] = 0xEB; macaddr.addr[2] = 0xEC;
	  macaddr.addr[3] = 0x12; macaddr.addr[4] = 0x34; macaddr.addr[5] = 0x56;

	  uip_setethaddr(macaddr);

	  uip_ipaddr(ipaddr, 192, 168, 100, 2);
	  uip_sethostaddr(ipaddr);

	  uip_ipaddr(ipaddr, 192, 168, 100, 1);
	  uip_setdraddr(ipaddr);

	  uip_ipaddr(ipaddr, 255, 255, 255, 0);
	  uip_setnetmask(ipaddr);

	  //MAC Filtering
	  HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x28, 0xEAEBEC12 );
	  HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x2C, 0x10003456 );
}

uint32_t MAC_rx_packet()
{
	  uint32_t temp, temp2 = 0;
	  uint32_t rx_stats = 0;
	  uint32_t rx_stats_avail = 0;
	  uint32_t i, j = 0;

	  uint32_t len = 0;

	  while(1)
	  {
		  temp2 = HW_get_32bit_reg(MAC10GBFIFO_BASE_ADDRESS + 0x14);
		  if ((temp2 & 0x100) == 0x100) break;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x10 );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
	  }
	  // get last words
	  if ((temp2 & 0xFF) == 0x0) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x1) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x2) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x3) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
	  }
	  else if ((temp2 & 0xFF) == 0x4) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x10 );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x5) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x10 );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x6) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x10 );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
	  }
	  else if ((temp2 & 0xFF) == 0x7) {
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x0C );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
		  temp = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x10 );
		  uip_buf[len] = (uint8_t)(temp >> 24); len++;
		  uip_buf[len] = (uint8_t)(temp >> 16); len++;
		  uip_buf[len] = (uint8_t)(temp >> 8); len++;
		  uip_buf[len] = (uint8_t)temp; len++;
	  }

	  return len;
}

void MAC_tx_packet(uint32_t len)
{
	uint32_t first, i, payload_word, payload_word2;
	uint8_t *payload_pointer;
	uint8_t bc = 0;
	uint32_t complete_bytes, remaining_bytes;

	uint32_t tx_stats = 0;
	uint32_t tx_stats_avail = 0;

    // remaining bytes of last pbuf 64Bit alignment
    remaining_bytes = len % 8;
    complete_bytes = len - remaining_bytes;
    i = 0;
    first = 0;
    while(i < complete_bytes)
    {
    	payload_word = ((uint32_t)uip_buf[i] << 24); i++;
    	payload_word |= ((uint32_t)uip_buf[i] << 16); i++;
    	payload_word |= ((uint32_t)uip_buf[i] << 8); i++;
    	payload_word |= (uint32_t)uip_buf[i]; i++;
    	HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x00, payload_word );
    	payload_word = ((uint32_t)uip_buf[i] << 24); i++;
    	payload_word |= ((uint32_t)uip_buf[i] << 16); i++;
    	payload_word |= ((uint32_t)uip_buf[i] << 8); i++;
    	payload_word |= (uint32_t)uip_buf[i]; i++;
    	HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x04, payload_word );
    	if (first == 0)
    	{
    		HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x08, 0x207 );
    		first = 1;
    	}
    	else
    	{
    		if (i == complete_bytes)
    		{
    			if (remaining_bytes == 0)
    			{
    				HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x08, 0x80000107 );
    				bc = 0x07;
    				break;
    			}
    			else
    			{
    				HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x08, 0x7 );
    				break;
    			}
    		}
    		else
    		{
    			HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x08, 0x7 );
    		}
    	}
    }
    	payload_word = 0; payload_word2 = 0;
    	if (remaining_bytes == 1) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24);
    		bc = 0x00;
    	}
    	else if (remaining_bytes == 2) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16);
    		bc = 0x01;
    	}
    	else if (remaining_bytes == 3) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 8);
    		bc = 0x02;
    	}
    	else if (remaining_bytes == 4) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 8); i++;
    		payload_word2 |= (uint32_t)uip_buf[i];
    		bc = 0x03;
    	}
    	else if (remaining_bytes == 5) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 8); i++;
    		payload_word2 |= (uint32_t)uip_buf[i]; i++;
    		payload_word = ((uint32_t)uip_buf[i] << 24);
    		bc = 0x04;
    	}
    	else if (remaining_bytes == 6) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 8); i++;
    		payload_word2 |= (uint32_t)uip_buf[i]; i++;
    		payload_word = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word |= ((uint32_t)uip_buf[i] << 16);
    		bc = 0x05;
    	}
    	else if (remaining_bytes == 7) {
    		payload_word2 = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word2 |= ((uint32_t)uip_buf[i] << 8); i++;
    		payload_word2 |= (uint32_t)uip_buf[i]; i++;
    		payload_word = ((uint32_t)uip_buf[i] << 24); i++;
    		payload_word |= ((uint32_t)uip_buf[i] << 16); i++;
    		payload_word |= ((uint32_t)uip_buf[i] << 8);
    		bc = 0x06;
    	}

    	if (bc != 0x07) {
    		HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x04, payload_word );
    		HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x00, payload_word2 );
    		HW_set_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x08, 0x80000100 | bc );
    	}

    	tx_stats_avail = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x24 );
    	if ((tx_stats_avail & 0x2) == 0x0)
    	{
    		tx_stats = HW_get_32bit_reg( MAC10GBFIFO_BASE_ADDRESS + 0x1C );
    	}

}

void check_tx_length(uint16_t *length)
{
	uint16_t i;

	if (*length < 60) {
		for (i=*length; i<60; i++)
			uip_buf[i] = 0;

		*length = 60;
	}
}

void configure_10GMAC(void)
{
	HAL_set_32bit_reg( MAC10GB_BASE_ADDRESS, MAC_TX_CONFIG_CONFIG, 0x1C000 );
	HAL_set_32bit_reg( MAC10GB_BASE_ADDRESS, MAC_TX_CONFIG_SYSTEM1, 0x10C );
	HAL_set_32bit_reg( MAC10GB_BASE_ADDRESS, MAC_RX_CONFIG_STATIC, 0x8 );
	HAL_set_32bit_reg( MAC10GB_BASE_ADDRESS, MAC_RX_CONFIG_CONFIG, 0x1C000 );
}
